# Class BridgeWrapper

#### Hierarchy

- ModuleWrapper<BridgeModule>
  - BridgeWrapper

#### Implements

- BridgeModule

- Defined in modules/packages/bridge/packages/wrapper/dist/types/BridgeWrapper.d.ts:5

#####
Index

### Constructors

constructor

### Properties

eventData
params
wrapperParams
defaultLogger?
requiredQueries

### Accessors

account
address
config
downResolver
logger
module
queries
targetDownResolver
upResolver

### Methods

bindQuery
bindQueryInternal
clearListeners
connect
describe
disconnect
discover
emit
emitSerial
filterErrors
listenerCount
off
offAny
on
onAny
once
previousHash
query
queryable
resolve
resolveWrapped
sendQuery
sendTargetQuery
targetConfig
targetDiscover
targetQueries
targetQuery
targetQueryable
targetResolve
throwErrors
canWrap
hasRequiredQueries
missingRequiredQueries
tryWrap
wrap

## Constructors

### constructor

- new BridgeWrapper(params): BridgeWrapper

- #### Parameters

  - ##### params: BaseParamsFields & {
    account?: AccountInstance;
    module: BridgeModule<BridgeParams<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: string;
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<Omit<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: "network.xyo.bridge.config";
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<{
    discoverCache?: true | CacheConfig;
    schema: "network.xyo.bridge.config";
    }, "schema">, "schema"> & {
    schema: string;
    }, "schema">>, ModuleEventData, Module<ModuleParams<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: string;
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<Omit<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: "network.xyo.module.config";
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<undefined, "schema">, "schema"> & {
    schema: string;
    }, "schema">, undefined>, ModuleEventData>>;
    }

  #### Returns BridgeWrapper

  Inherited from ModuleWrapper.constructor

  - Defined in modules/packages/module/packages/wrapper/dist/types/Wrapper.d.ts:29

## Properties

### eventData

eventData: ModuleEventData

Implementation of BridgeModule.eventData

Inherited from ModuleWrapper.eventData

- Defined in modules/packages/module/packages/wrapper/dist/types/Wrapper.d.ts:27

### `Readonly` params

params: BridgeParams<SchemaFields & PayloadFields & {
archivist?: ArchivistModuleConfig;
name?: string;
paging?: Record<string, {
size?: number;
}>;
schema: string;
security?: {
allowAnonymous?: boolean;
allowed?: Record<string, (string | CosigningAddressSet)[]>;
disallowed?: Record<string, string[]>;
};
storeQueries?: boolean;
} & Omit<Omit<SchemaFields & PayloadFields & {
archivist?: ArchivistModuleConfig;
name?: string;
paging?: Record<string, {
size?: number;
}>;
schema: "network.xyo.bridge.config";
security?: {
allowAnonymous?: boolean;
allowed?: Record<string, (string | CosigningAddressSet)[]>;
disallowed?: Record<string, string[]>;
};
storeQueries?: boolean;
} & Omit<{
discoverCache?: true | CacheConfig;
schema: "network.xyo.bridge.config";
}, "schema">, "schema"> & {
schema: string;
}, "schema">>

Implementation of BridgeModule.params

Inherited from ModuleWrapper.params

- Defined in protocol/packages/core/dist/types/lib/Base.d.ts:20

### `Protected` `Readonly` wrapperParams

wrapperParams: BaseParamsFields & {
account?: AccountInstance;
module: BridgeModule<BridgeParams<SchemaFields & PayloadFields & {
archivist?: ArchivistModuleConfig;
name?: string;
paging?: Record<string, {
size?: number;
}>;
schema: string;
security?: {
allowAnonymous?: boolean;
allowed?: Record<string, (string | CosigningAddressSet)[]>;
disallowed?: Record<string, string[]>;
};
storeQueries?: boolean;
} & Omit<Omit<SchemaFields & PayloadFields & {
archivist?: ArchivistModuleConfig;
name?: string;
paging?: Record<string, {
size?: number;
}>;
schema: "network.xyo.bridge.config";
security?: {
allowAnonymous?: boolean;
allowed?: Record<string, (string | CosigningAddressSet)[]>;
disallowed?: Record<string, string[]>;
};
storeQueries?: boolean;
} & Omit<{
discoverCache?: true | CacheConfig;
schema: "network.xyo.bridge.config";
}, "schema">, "schema"> & {
schema: string;
}, "schema">>, ModuleEventData, Module<ModuleParams<SchemaFields & PayloadFields & {
archivist?: ArchivistModuleConfig;
name?: string;
paging?: Record<string, {
size?: number;
}>;
schema: string;
security?: {
allowAnonymous?: boolean;
allowed?: Record<string, (string | CosigningAddressSet)[]>;
disallowed?: Record<string, string[]>;
};
storeQueries?: boolean;
} & Omit<Omit<SchemaFields & PayloadFields & {
archivist?: ArchivistModuleConfig;
name?: string;
paging?: Record<string, {
size?: number;
}>;
schema: "network.xyo.module.config";
security?: {
allowAnonymous?: boolean;
allowed?: Record<string, (string | CosigningAddressSet)[]>;
disallowed?: Record<string, string[]>;
};
storeQueries?: boolean;
} & Omit<undefined, "schema">, "schema"> & {
schema: string;
}, "schema">, undefined>, ModuleEventData>>;
}

Inherited from ModuleWrapper.wrapperParams

- Defined in modules/packages/module/packages/wrapper/dist/types/Wrapper.d.ts:28

### `Static` `Optional` defaultLogger

defaultLogger?: Logger

Inherited from ModuleWrapper.defaultLogger

- Defined in protocol/packages/core/dist/types/lib/Base.d.ts:21

### `Static` requiredQueries

requiredQueries: string[]

Inherited from ModuleWrapper.requiredQueries

- Defined in modules/packages/module/packages/wrapper/dist/types/Wrapper.d.ts:26

## Accessors

### account

- get account(): undefined | AccountInstance

- #### Returns undefined | AccountInstance

  Inherited from ModuleWrapper.account

  - Defined in modules/packages/module/packages/wrapper/dist/types/Wrapper.d.ts:30

### address

- get address(): string

- #### Returns string

  Implementation of BridgeModule.address

  Inherited from ModuleWrapper.address

  - Defined in modules/packages/module/packages/wrapper/dist/types/Wrapper.d.ts:31

### config

- get config(): TWrappedModule["config"]

- #### Returns TWrappedModule["config"]

  Implementation of BridgeModule.config

  Inherited from ModuleWrapper.config

  - Defined in modules/packages/module/packages/wrapper/dist/types/Wrapper.d.ts:32

### downResolver

- get downResolver(): ModuleResolver

- #### Returns ModuleResolver

  Implementation of BridgeModule.downResolver

  Inherited from ModuleWrapper.downResolver

  - Defined in modules/packages/module/packages/wrapper/dist/types/Wrapper.d.ts:33

### `Protected` logger

- get logger(): Logger | Console

- #### Returns Logger | Console

  Inherited from ModuleWrapper.logger

  - Defined in protocol/packages/core/dist/types/lib/Base.d.ts:23

### module

- get module(): TWrappedModule

- #### Returns TWrappedModule

  Inherited from ModuleWrapper.module

  - Defined in modules/packages/module/packages/wrapper/dist/types/Wrapper.d.ts:34

### queries

- get queries(): string[]

- #### Returns string[]

  Implementation of BridgeModule.queries

  Inherited from ModuleWrapper.queries

  - Defined in modules/packages/module/packages/wrapper/dist/types/Wrapper.d.ts:35

### targetDownResolver

- get targetDownResolver(): ((address?) => ModuleResolver)

- #### Returns ((address?) => ModuleResolver)

  - - (address?): ModuleResolver

    - #### Parameters

      - ##### `Optional` address: string

      #### Returns ModuleResolver

  Implementation of BridgeModule.targetDownResolver

  - Defined in modules/packages/bridge/packages/wrapper/dist/types/BridgeWrapper.d.ts:6

### upResolver

- get upResolver(): ModuleResolver

- #### Returns ModuleResolver

  Implementation of BridgeModule.upResolver

  Inherited from ModuleWrapper.upResolver

  - Defined in modules/packages/module/packages/wrapper/dist/types/Wrapper.d.ts:36

## Methods

### `Protected` bindQuery

- bindQuery<T>(query, payloads?, account?): PromiseEx<[SchemaFields & PayloadFields & BoundWitnessFields & {
  query: string;
  resultSet?: string;
  schema: "network.xyo.boundwitness";
  }, (SchemaFields & PayloadFields & {
  schema: string;
  })[]], AccountInstance>

- #### Type Parameters

  - #### T extends SchemaFields & PayloadFields & QueryFields & {
    schema: string;
    } | PayloadWrapper<SchemaFields & PayloadFields & QueryFields & {
    schema: string;
    }>

  #### Parameters

  - ##### query: T

  - ##### `Optional` payloads: (SchemaFields & PayloadFields & {
    schema: string;
    })[]

  - ##### `Optional` account: AccountInstance

  #### Returns PromiseEx<[SchemaFields & PayloadFields & BoundWitnessFields & {
  query: string;
  resultSet?: string;
  schema: "network.xyo.boundwitness";
  }, (SchemaFields & PayloadFields & {
  schema: string;
  })[]], AccountInstance>

  Inherited from ModuleWrapper.bindQuery

  - Defined in modules/packages/module/packages/wrapper/dist/types/Wrapper.d.ts:71

### `Protected` bindQueryInternal

- bindQueryInternal<T>(query, payloads?, account?): Promise<[SchemaFields & PayloadFields & BoundWitnessFields & {
  query: string;
  resultSet?: string;
  schema: "network.xyo.boundwitness";
  }, (SchemaFields & PayloadFields & {
  schema: string;
  })[]]>

- #### Type Parameters

  - #### T extends SchemaFields & PayloadFields & QueryFields & {
    schema: string;
    } | PayloadWrapper<SchemaFields & PayloadFields & QueryFields & {
    schema: string;
    }>

  #### Parameters

  - ##### query: T

  - ##### `Optional` payloads: (SchemaFields & PayloadFields & {
    schema: string;
    })[]

  - ##### `Optional` account: AccountInstance

  #### Returns Promise<[SchemaFields & PayloadFields & BoundWitnessFields & {
  query: string;
  resultSet?: string;
  schema: "network.xyo.boundwitness";
  }, (SchemaFields & PayloadFields & {
  schema: string;
  })[]]>

  Inherited from ModuleWrapper.bindQueryInternal

  - Defined in modules/packages/module/packages/wrapper/dist/types/Wrapper.d.ts:72

### clearListeners

- clearListeners(eventNames): void

- #### Parameters

  - ##### eventNames: keyof ModuleEventData | (keyof ModuleEventData)[]

  #### Returns void

  Implementation of BridgeModule.clearListeners

  Inherited from ModuleWrapper.clearListeners

  - Defined in modules/packages/module/packages/wrapper/dist/types/Wrapper.d.ts:42

### connect

- connect(uri?): Promise<boolean>

- #### Parameters

  - ##### `Optional` uri: string

  #### Returns Promise<boolean>

  Implementation of BridgeModule.connect

  - Defined in modules/packages/bridge/packages/wrapper/dist/types/BridgeWrapper.d.ts:7

### describe

- describe(): Promise<Promise<Promisable<ModuleDescription, never>>>

- #### Returns Promise<Promise<Promisable<ModuleDescription, never>>>

  Inherited from ModuleWrapper.describe

  - Defined in modules/packages/module/packages/wrapper/dist/types/Wrapper.d.ts:43

### disconnect

- disconnect(uri?): Promise<boolean>

- #### Parameters

  - ##### `Optional` uri: string

  #### Returns Promise<boolean>

  Implementation of BridgeModule.disconnect

  - Defined in modules/packages/bridge/packages/wrapper/dist/types/BridgeWrapper.d.ts:8

### discover

- discover(): Promise<(SchemaFields & PayloadFields & {
  schema: string;
  })[]>

- #### Returns Promise<(SchemaFields & PayloadFields & {
  schema: string;
  })[]>

  Inherited from ModuleWrapper.discover

  - Defined in modules/packages/module/packages/wrapper/dist/types/Wrapper.d.ts:44

### emit

- emit(eventName, eventArgs): Promise<void>

- #### Parameters

  - ##### eventName: keyof ModuleEventData

  - ##### eventArgs: EventArgs

  #### Returns Promise<void>

  Implementation of BridgeModule.emit

  Inherited from ModuleWrapper.emit

  - Defined in modules/packages/module/packages/wrapper/dist/types/Wrapper.d.ts:45

### emitSerial

- emitSerial(eventName, eventArgs): Promise<void>

- #### Parameters

  - ##### eventName: keyof ModuleEventData

  - ##### eventArgs: EventArgs

  #### Returns Promise<void>

  Implementation of BridgeModule.emitSerial

  Inherited from ModuleWrapper.emitSerial

  - Defined in modules/packages/module/packages/wrapper/dist/types/Wrapper.d.ts:46

### `Protected` filterErrors

- filterErrors(query, result): (null | SchemaFields & PayloadFields & {
  message?: string;
  schema: "network.xyo.error.module";
  sources?: string[];
  })[]

- #### Parameters

  - ##### query: [SchemaFields & PayloadFields & BoundWitnessFields & {
    query: string;
    resultSet?: string;
    schema: "network.xyo.boundwitness";
    }, (SchemaFields & PayloadFields & {
    schema: string;
    })[]]

  - ##### result: undefined | ModuleQueryResult<SchemaFields & PayloadFields & {
    schema: string;
    }>

  #### Returns (null | SchemaFields & PayloadFields & {
  message?: string;
  schema: "network.xyo.error.module";
  sources?: string[];
  })[]

  Inherited from ModuleWrapper.filterErrors

  - Defined in modules/packages/module/packages/wrapper/dist/types/Wrapper.d.ts:73

### listenerCount

- listenerCount(eventNames): number

- #### Parameters

  - ##### eventNames: keyof ModuleEventData | (keyof ModuleEventData)[]

  #### Returns number

  Implementation of BridgeModule.listenerCount

  Inherited from ModuleWrapper.listenerCount

  - Defined in modules/packages/module/packages/wrapper/dist/types/Wrapper.d.ts:47

### off

- off<TEventName>(eventNames, listener): void

- #### Type Parameters

  - #### TEventName extends keyof ModuleEventData

  #### Parameters

  - ##### eventNames: TEventName

  - ##### listener: EventListener<ModuleEventData[TEventName]>

  #### Returns void

  Implementation of BridgeModule.off

  Inherited from ModuleWrapper.off

  - Defined in modules/packages/module/packages/wrapper/dist/types/Wrapper.d.ts:48

### offAny

- offAny(listener): void

- #### Parameters

  - ##### listener: EventAnyListener<EventArgs>

  #### Returns void

  Implementation of BridgeModule.offAny

  Inherited from ModuleWrapper.offAny

  - Defined in modules/packages/module/packages/wrapper/dist/types/Wrapper.d.ts:49

### on

- on<TEventName>(eventNames, listener): EventUnsubscribeFunction

- #### Type Parameters

  - #### TEventName extends keyof ModuleEventData

  #### Parameters

  - ##### eventNames: TEventName

  - ##### listener: EventListener<ModuleEventData[TEventName]>

  #### Returns EventUnsubscribeFunction

  Implementation of BridgeModule.on

  Inherited from ModuleWrapper.on

  - Defined in modules/packages/module/packages/wrapper/dist/types/Wrapper.d.ts:50

### onAny

- onAny(listener): EventUnsubscribeFunction

- #### Parameters

  - ##### listener: EventAnyListener<EventArgs>

  #### Returns EventUnsubscribeFunction

  Implementation of BridgeModule.onAny

  Inherited from ModuleWrapper.onAny

  - Defined in modules/packages/module/packages/wrapper/dist/types/Wrapper.d.ts:51

### once

- once<TEventName>(eventName, listener): EventUnsubscribeFunction

- #### Type Parameters

  - #### TEventName extends keyof ModuleEventData

  #### Parameters

  - ##### eventName: TEventName

  - ##### listener: EventListener<ModuleEventData[TEventName]>

  #### Returns EventUnsubscribeFunction

  Implementation of BridgeModule.once

  Inherited from ModuleWrapper.once

  - Defined in modules/packages/module/packages/wrapper/dist/types/Wrapper.d.ts:52

### previousHash

- previousHash(): Promise<(SchemaFields & PayloadFields & {
  schema: string;
  })[]>

- #### Returns Promise<(SchemaFields & PayloadFields & {
  schema: string;
  })[]>

  Inherited from ModuleWrapper.previousHash

  - Defined in modules/packages/module/packages/wrapper/dist/types/Wrapper.d.ts:53

### query

- query<T>(query, payloads?): Promise<ModuleQueryResult<SchemaFields & PayloadFields & {
  schema: string;
  }>>

- #### Type Parameters

  - #### T extends SchemaFields & PayloadFields & BoundWitnessFields & {
    query: string;
    resultSet?: string;
    schema: "network.xyo.boundwitness";
    } = SchemaFields & PayloadFields & BoundWitnessFields & {
    query: string;
    resultSet?: string;
    schema: "network.xyo.boundwitness";
    }

  #### Parameters

  - ##### query: T

  - ##### `Optional` payloads: (SchemaFields & PayloadFields & {
    schema: string;
    })[]

  #### Returns Promise<ModuleQueryResult<SchemaFields & PayloadFields & {
  schema: string;
  }>>

  Implementation of BridgeModule.query

  Inherited from ModuleWrapper.query

  - Defined in modules/packages/module/packages/wrapper/dist/types/Wrapper.d.ts:54

### queryable

- queryable<T>(query, payloads?): Promisable<boolean, never>

- #### Type Parameters

  - #### T extends SchemaFields & PayloadFields & BoundWitnessFields & {
    query: string;
    resultSet?: string;
    schema: "network.xyo.boundwitness";
    } = SchemaFields & PayloadFields & BoundWitnessFields & {
    query: string;
    resultSet?: string;
    schema: "network.xyo.boundwitness";
    }

  #### Parameters

  - ##### query: T

  - ##### `Optional` payloads: (SchemaFields & PayloadFields & {
    schema: string;
    })[]

  #### Returns Promisable<boolean, never>

  Implementation of BridgeModule.queryable

  Inherited from ModuleWrapper.queryable

  - Defined in modules/packages/module/packages/wrapper/dist/types/Wrapper.d.ts:55

### resolve

- resolve<TModule>(filter?): Promise<TModule[]>

- #### Type Parameters

  - #### TModule extends ModuleFields<ModuleParams<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: string;
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<Omit<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: "network.xyo.module.config";
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<undefined, "schema">, "schema"> & {
    schema: string;
    }, "schema">, undefined>> & EventFunctions<ModuleEventData, TModule> = Module<ModuleParams<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: string;
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<Omit<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: "network.xyo.module.config";
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<undefined, "schema">, "schema"> & {
    schema: string;
    }, "schema">, undefined>, ModuleEventData>

  #### Parameters

  - ##### `Optional` filter: ModuleFilter

  #### Returns Promise<TModule[]>

  Inherited from ModuleWrapper.resolve

  - Defined in modules/packages/module/packages/wrapper/dist/types/Wrapper.d.ts:56
- resolve<TModule>(nameOrAddress): Promise<undefined | TModule>

- #### Type Parameters

  - #### TModule extends ModuleFields<ModuleParams<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: string;
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<Omit<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: "network.xyo.module.config";
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<undefined, "schema">, "schema"> & {
    schema: string;
    }, "schema">, undefined>> & EventFunctions<ModuleEventData, TModule> = Module<ModuleParams<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: string;
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<Omit<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: "network.xyo.module.config";
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<undefined, "schema">, "schema"> & {
    schema: string;
    }, "schema">, undefined>, ModuleEventData>

  #### Parameters

  - ##### nameOrAddress: string

  #### Returns Promise<undefined | TModule>

  Inherited from ModuleWrapper.resolve

  - Defined in modules/packages/module/packages/wrapper/dist/types/Wrapper.d.ts:57

### resolveWrapped

- resolveWrapped<T>(wrapper, filter?): Promise<T[]>

- Resolves the supplied filter into wrapped modules

  ### Example

  Example using ArchivistWrapper

      const filter = { address: [address] }
      const mods: ArchivistWrapper[] = await node.resolveWrapped(ArchivistWrapper, filter)

  #### Type Parameters

  - #### T extends ModuleWrapper<Module<ModuleParams<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: string;
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<Omit<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: "network.xyo.module.config";
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<undefined, "schema">, "schema"> & {
    schema: string;
    }, "schema">, undefined>, ModuleEventData>, T> = ModuleWrapper<Module<ModuleParams<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: string;
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<Omit<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: "network.xyo.module.config";
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<undefined, "schema">, "schema"> & {
    schema: string;
    }, "schema">, undefined>, ModuleEventData>>

  #### Parameters

  - ##### wrapper: ConstructableModuleWrapper<T>

    The ModuleWrapper class (ArchivistWrapper, DivinerWrapper, etc.)

  - ##### `Optional` filter: ModuleFilter

    The ModuleFilter

  #### Returns Promise<T[]>

  An array of ModuleWrapper instances corresponding to the underlying modules matching the supplied filter

  Inherited from ModuleWrapper.resolveWrapped

  - Defined in modules/packages/module/packages/wrapper/dist/types/Wrapper.d.ts:69
- resolveWrapped<T>(wrapper, nameOrAddress): Promise<undefined | T>

- #### Type Parameters

  - #### T extends ModuleWrapper<Module<ModuleParams<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: string;
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<Omit<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: "network.xyo.module.config";
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<undefined, "schema">, "schema"> & {
    schema: string;
    }, "schema">, undefined>, ModuleEventData>, T> = ModuleWrapper<Module<ModuleParams<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: string;
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<Omit<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: "network.xyo.module.config";
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<undefined, "schema">, "schema"> & {
    schema: string;
    }, "schema">, undefined>, ModuleEventData>>

  #### Parameters

  - ##### wrapper: ConstructableModuleWrapper<T>

  - ##### nameOrAddress: string

  #### Returns Promise<undefined | T>

  Inherited from ModuleWrapper.resolveWrapped

  - Defined in modules/packages/module/packages/wrapper/dist/types/Wrapper.d.ts:70

### `Protected` sendQuery

- sendQuery<T>(queryPayload, payloads?): Promise<(SchemaFields & PayloadFields & {
  schema: string;
  })[]>

- #### Type Parameters

  - #### T extends SchemaFields & PayloadFields & QueryFields & {
    schema: string;
    } | PayloadWrapper<SchemaFields & PayloadFields & QueryFields & {
    schema: string;
    }>

  #### Parameters

  - ##### queryPayload: T

  - ##### `Optional` payloads: (SchemaFields & PayloadFields & {
    schema: string;
    })[]

  #### Returns Promise<(SchemaFields & PayloadFields & {
  schema: string;
  })[]>

  Inherited from ModuleWrapper.sendQuery

  - Defined in modules/packages/module/packages/wrapper/dist/types/Wrapper.d.ts:74

### `Protected` sendTargetQuery

- sendTargetQuery<T>(address, queryPayload, payloads?): Promise<undefined | (SchemaFields & PayloadFields & {
  schema: string;
  })[]>

- #### Type Parameters

  - #### T extends SchemaFields & PayloadFields & QueryFields & {
    schema: string;
    } | PayloadWrapper<SchemaFields & PayloadFields & QueryFields & {
    schema: string;
    }>

  #### Parameters

  - ##### address: string

  - ##### queryPayload: T

  - ##### `Optional` payloads: (SchemaFields & PayloadFields & {
    schema: string;
    })[]

  #### Returns Promise<undefined | (SchemaFields & PayloadFields & {
  schema: string;
  })[]>

  - Defined in modules/packages/bridge/packages/wrapper/dist/types/BridgeWrapper.d.ts:43

### targetConfig

- targetConfig(address): SchemaFields & PayloadFields & {
  archivist?: ArchivistModuleConfig;
  name?: string;
  paging?: Record<string, {
  size?: number;
  }>;
  schema: "network.xyo.module.config";
  security?: {
  allowAnonymous?: boolean;
  allowed?: Record<string, (string | CosigningAddressSet)[]>;
  disallowed?: Record<string, string[]>;
  };
  storeQueries?: boolean;
  } & Omit<undefined, "schema">

- #### Parameters

  - ##### address: string

  #### Returns SchemaFields & PayloadFields & {
  archivist?: ArchivistModuleConfig;
  name?: string;
  paging?: Record<string, {
  size?: number;
  }>;
  schema: "network.xyo.module.config";
  security?: {
  allowAnonymous?: boolean;
  allowed?: Record<string, (string | CosigningAddressSet)[]>;
  disallowed?: Record<string, string[]>;
  };
  storeQueries?: boolean;
  } & Omit<undefined, "schema">

  Implementation of BridgeModule.targetConfig

  - Defined in modules/packages/bridge/packages/wrapper/dist/types/BridgeWrapper.d.ts:9

### targetDiscover

- targetDiscover(address): Promise<undefined | (SchemaFields & PayloadFields & {
  schema: string;
  })[]>

- #### Parameters

  - ##### address: string

  #### Returns Promise<undefined | (SchemaFields & PayloadFields & {
  schema: string;
  })[]>

  Implementation of BridgeModule.targetDiscover

  - Defined in modules/packages/bridge/packages/wrapper/dist/types/BridgeWrapper.d.ts:10

### targetQueries

- targetQueries(address): string[]

- #### Parameters

  - ##### address: string

  #### Returns string[]

  Implementation of BridgeModule.targetQueries

  - Defined in modules/packages/bridge/packages/wrapper/dist/types/BridgeWrapper.d.ts:11

### targetQuery

- targetQuery<T>(address, query, payloads?): Promise<undefined | ModuleQueryResult<SchemaFields & PayloadFields & {
  schema: string;
  }>>

- #### Type Parameters

  - #### T extends SchemaFields & PayloadFields & BoundWitnessFields & {
    query: string;
    resultSet?: string;
    schema: "network.xyo.boundwitness";
    } = SchemaFields & PayloadFields & BoundWitnessFields & {
    query: string;
    resultSet?: string;
    schema: "network.xyo.boundwitness";
    }

  #### Parameters

  - ##### address: string

  - ##### query: T

  - ##### `Optional` payloads: (SchemaFields & PayloadFields & {
    schema: string;
    })[]

  #### Returns Promise<undefined | ModuleQueryResult<SchemaFields & PayloadFields & {
  schema: string;
  }>>

  Implementation of BridgeModule.targetQuery

  - Defined in modules/packages/bridge/packages/wrapper/dist/types/BridgeWrapper.d.ts:12

### targetQueryable

- targetQueryable(address, query, payloads?, queryConfig?): Promise<boolean>

- #### Parameters

  - ##### address: string

  - ##### query: SchemaFields & PayloadFields & BoundWitnessFields & {
    query: string;
    resultSet?: string;
    schema: "network.xyo.boundwitness";
    }

  - ##### `Optional` payloads: (SchemaFields & PayloadFields & {
    schema: string;
    })[]

  - ##### `Optional` queryConfig: SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: "network.xyo.module.config";
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<undefined, "schema">

  #### Returns Promise<boolean>

  Implementation of BridgeModule.targetQueryable

  - Defined in modules/packages/bridge/packages/wrapper/dist/types/BridgeWrapper.d.ts:13

### targetResolve

- targetResolve(address, filter?): Promise<Module<ModuleParams<SchemaFields & PayloadFields & {
  archivist?: ArchivistModuleConfig;
  name?: string;
  paging?: Record<string, {
  size?: number;
  }>;
  schema: string;
  security?: {
  allowAnonymous?: boolean;
  allowed?: Record<string, (string | CosigningAddressSet)[]>;
  disallowed?: Record<string, string[]>;
  };
  storeQueries?: boolean;
  } & Omit<Omit<SchemaFields & PayloadFields & {
  archivist?: ArchivistModuleConfig;
  name?: string;
  paging?: Record<string, {
  size?: number;
  }>;
  schema: "network.xyo.module.config";
  security?: {
  allowAnonymous?: boolean;
  allowed?: Record<string, (string | CosigningAddressSet)[]>;
  disallowed?: Record<string, string[]>;
  };
  storeQueries?: boolean;
  } & Omit<undefined, "schema">, "schema"> & {
  schema: string;
  }, "schema">, undefined>, ModuleEventData>[]>

- #### Parameters

  - ##### address: string

  - ##### `Optional` filter: ModuleFilter

  #### Returns Promise<Module<ModuleParams<SchemaFields & PayloadFields & {
  archivist?: ArchivistModuleConfig;
  name?: string;
  paging?: Record<string, {
  size?: number;
  }>;
  schema: string;
  security?: {
  allowAnonymous?: boolean;
  allowed?: Record<string, (string | CosigningAddressSet)[]>;
  disallowed?: Record<string, string[]>;
  };
  storeQueries?: boolean;
  } & Omit<Omit<SchemaFields & PayloadFields & {
  archivist?: ArchivistModuleConfig;
  name?: string;
  paging?: Record<string, {
  size?: number;
  }>;
  schema: "network.xyo.module.config";
  security?: {
  allowAnonymous?: boolean;
  allowed?: Record<string, (string | CosigningAddressSet)[]>;
  disallowed?: Record<string, string[]>;
  };
  storeQueries?: boolean;
  } & Omit<undefined, "schema">, "schema"> & {
  schema: string;
  }, "schema">, undefined>, ModuleEventData>[]>

  Implementation of BridgeModule.targetResolve

  - Defined in modules/packages/bridge/packages/wrapper/dist/types/BridgeWrapper.d.ts:14

### `Protected` throwErrors

- throwErrors(query, result): void

- #### Parameters

  - ##### query: [SchemaFields & PayloadFields & BoundWitnessFields & {
    query: string;
    resultSet?: string;
    schema: "network.xyo.boundwitness";
    }, (SchemaFields & PayloadFields & {
    schema: string;
    })[]]

  - ##### result: undefined | ModuleQueryResult<SchemaFields & PayloadFields & {
    schema: string;
    }>

  #### Returns void

  Inherited from ModuleWrapper.throwErrors

  - Defined in modules/packages/module/packages/wrapper/dist/types/Wrapper.d.ts:75

### `Static` canWrap

- canWrap(module?): boolean

- #### Parameters

  - ##### `Optional` module: Module<ModuleParams<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: string;
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<Omit<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: "network.xyo.module.config";
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<undefined, "schema">, "schema"> & {
    schema: string;
    }, "schema">, undefined>, ModuleEventData>

  #### Returns boolean

  Inherited from ModuleWrapper.canWrap

  - Defined in modules/packages/module/packages/wrapper/dist/types/Wrapper.d.ts:37

### `Static` hasRequiredQueries

- hasRequiredQueries(module): boolean

- #### Parameters

  - ##### module: Module<ModuleParams<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: string;
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<Omit<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: "network.xyo.module.config";
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<undefined, "schema">, "schema"> & {
    schema: string;
    }, "schema">, undefined>, ModuleEventData>

  #### Returns boolean

  Inherited from ModuleWrapper.hasRequiredQueries

  - Defined in modules/packages/module/packages/wrapper/dist/types/Wrapper.d.ts:38

### `Static` missingRequiredQueries

- missingRequiredQueries(module): string[]

- #### Parameters

  - ##### module: Module<ModuleParams<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: string;
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<Omit<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: "network.xyo.module.config";
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<undefined, "schema">, "schema"> & {
    schema: string;
    }, "schema">, undefined>, ModuleEventData>

  #### Returns string[]

  Inherited from ModuleWrapper.missingRequiredQueries

  - Defined in modules/packages/module/packages/wrapper/dist/types/Wrapper.d.ts:39

### `Static` tryWrap

- tryWrap<TModuleWrapper>(this, module?, account?): undefined | TModuleWrapper

- #### Type Parameters

  - #### TModuleWrapper extends ModuleWrapper<Module<ModuleParams<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: string;
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<Omit<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: "network.xyo.module.config";
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<undefined, "schema">, "schema"> & {
    schema: string;
    }, "schema">, undefined>, ModuleEventData>, TModuleWrapper>

  #### Parameters

  - ##### this: ConstructableModuleWrapper<TModuleWrapper>

  - ##### `Optional` module: Module<ModuleParams<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: string;
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<Omit<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: "network.xyo.module.config";
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<undefined, "schema">, "schema"> & {
    schema: string;
    }, "schema">, undefined>, ModuleEventData>

  - ##### `Optional` account: AccountInstance

  #### Returns undefined | TModuleWrapper

  Inherited from ModuleWrapper.tryWrap

  - Defined in modules/packages/module/packages/wrapper/dist/types/Wrapper.d.ts:40

### `Static` wrap

- wrap<TModuleWrapper>(this, module?, account?): TModuleWrapper

- #### Type Parameters

  - #### TModuleWrapper extends ModuleWrapper<Module<ModuleParams<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: string;
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<Omit<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: "network.xyo.module.config";
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<undefined, "schema">, "schema"> & {
    schema: string;
    }, "schema">, undefined>, ModuleEventData>, TModuleWrapper>

  #### Parameters

  - ##### this: ConstructableModuleWrapper<TModuleWrapper>

  - ##### `Optional` module: Module<ModuleParams<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: string;
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<Omit<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: "network.xyo.module.config";
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<undefined, "schema">, "schema"> & {
    schema: string;
    }, "schema">, undefined>, ModuleEventData>

  - ##### `Optional` account: AccountInstance

  #### Returns TModuleWrapper

  Inherited from ModuleWrapper.wrap

  - Defined in modules/packages/module/packages/wrapper/dist/types/Wrapper.d.ts:41

Generated using TypeDoc